<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateDailyQualityBagInspectionDatasTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('qc_daily_quality_bag_inspection_data', function (Blueprint $table) {
            $table->id('dq_bag_inspection_data_id');
            $table->integer('dq_bag_inspection_id');
            $table->integer('hour');
            $table->decimal('print_damage');
            $table->decimal('unseal_damage');
            $table->decimal('seal_burning');
            $table->decimal('bag_damage');
            $table->decimal('plant_hole_damage');
            $table->decimal('upside_down');
            $table->decimal('production_damage');
            $table->decimal('qc_print_damage');
            $table->decimal('qc_unseal_damage');
            $table->decimal('qc_seal_burning');
            $table->decimal('qc_bag_damage');
            $table->decimal('qc_plant_hole_damage');
            $table->decimal('qc_upside_down');
            $table->decimal('qc_production_damage');
            $table->text('remarks')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('qc_daily_quality_bag_inspection_data');
    }
}
