<?php

namespace Modules\Qc\Http\Controllers;

use Exception;
use Illuminate\Support\Facades\Auth;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Qc\Entities\PackingMaterialChecklist;
use Modules\Qc\Entities\PackingMaterialChecklistHeader;

class PackingMaterialChecklistController extends Controller
{

    public function save(Request $request)
    {
        try {
            $rec = new PackingMaterialChecklistHeader();
            $rec->user_id = Auth::user()->id;
            $rec->reference_no = $request->get('reference_no');
            $rec->date = $request->get('date');
            $rec->supplier_name = $request->get('supplier_name');
            $rec->factory = $request->get('factory');
            $rec->strapping_rolls = $request->get('strapping_rolls');
            $rec->clips = $request->get('clips');
            $rec->film_rolls = $request->get('film_rolls');
            $rec->carton_pack = $request->get('carton_pack');

            $pm_data = $request->get('pm_data');
            if ($rec->save()) {
                $pm_rec = new PackingMaterialChecklist();
                $pm_rec->packing_material_id = $rec->packing_material_id;

                $pm_rec->weight_strapping_rolls = $pm_data['strapping_rolls']['weight_strapping_rolls'];
                $pm_rec->thickness_strapping_rolls = $pm_data['strapping_rolls']['thickness_strapping_rolls'];
                $pm_rec->appearance_strapping_rolls = $pm_data['strapping_rolls']['appearance_strapping_rolls'];
                $pm_rec->width_strapping_rolls = $pm_data['strapping_rolls']['width_strapping_rolls'];
                $pm_rec->remarks_strapping_rolls = $pm_data['strapping_rolls']['remarks_strapping_rolls'];

                $pm_rec->hardness_clips = $pm_data['clips']['hardness_clips'];
                $pm_rec->remarks_clips = $pm_data['clips']['remarks_clips'];

                $pm_rec->old_weight_film_roll = $pm_data['film_rolls']['old_weight_film_roll'];
                $pm_rec->new_weight_film_roll = $pm_data['film_rolls']['new_weight_film_roll'];
                $pm_rec->old_appearance_film_roll = $pm_data['film_rolls']['old_appearance_film_roll'];
                $pm_rec->new_appearance_film_roll = $pm_data['film_rolls']['new_appearance_film_roll'];
                $pm_rec->old_is_sticky_film_roll = $pm_data['film_rolls']['old_is_sticky_film_roll'];
                $pm_rec->new_is_sticky_film_roll = $pm_data['film_rolls']['new_is_sticky_film_roll'];
                $pm_rec->remarks_film_roll = $pm_data['film_rolls']['remarks_film_roll'];

                $pm_rec->old_internal_length_carton_packings = $pm_data['carton']['old_internal_length_carton_packings'];
                $pm_rec->old_internal_height_carton_packings = $pm_data['carton']['old_internal_height_carton_packings'];
                $pm_rec->old_internal_width_carton_packings = $pm_data['carton']['old_internal_width_carton_packings'];
                $pm_rec->new_internal_length_carton_packings = $pm_data['carton']['new_internal_length_carton_packings'];
                $pm_rec->new_internal_width_carton_packings = $pm_data['carton']['new_internal_width_carton_packings'];
                $pm_rec->new_internal_height_carton_packings = $pm_data['carton']['new_internal_height_carton_packings'];
                $pm_rec->old_external_length_carton_packings = $pm_data['carton']['old_external_length_carton_packings'];
                $pm_rec->old_external_height_carton_packings = $pm_data['carton']['old_external_height_carton_packings'];
                $pm_rec->old_external_width_carton_packings = $pm_data['carton']['old_external_width_carton_packings'];
                $pm_rec->new_external_length_carton_packings = $pm_data['carton']['new_external_length_carton_packings'];
                $pm_rec->new_external_width_carton_packings = $pm_data['carton']['new_external_width_carton_packings'];
                $pm_rec->new_external_height_carton_packings = $pm_data['carton']['new_external_height_carton_packings'];
                $pm_rec->weight_carton_packings = $pm_data['carton']['weight_carton_packings'];
                $pm_rec->appearance_carton_packings = $pm_data['carton']['appearance_carton_packings'];
                $pm_rec->no_of_ply_carton_packings = $pm_data['carton']['no_of_ply_carton_packings'];
                $pm_rec->color_carton_packings = $pm_data['carton']['color_carton_packings'];
                $pm_rec->remarks_carton_packings = $pm_data['carton']['remarks_carton_packings'];

                $pm_rec->save();
            }
            $responseBody = $this->responseBody(true, "PackingMaterialChecklistController", "saved", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingMaterialChecklistController", "error", $pm_data['strapping_rolls']['weight_strapping_rolls']);
        }

        return response()->json(["data" => $responseBody]);
    }

    public function getPackingMaterialData($id)
    {
        try {
            $recordHead = PackingMaterialChecklistHeader::find($id);
            $recordData = PackingMaterialChecklist::find($id);


            $recordHead->request_data = $recordData;

            $responseBody = $this->responseBody(true, "PackingMaterialChecklistController", "getPackingMaterialData", $recordHead);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingMaterialChecklistController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function update(Request $request, $id)
    {

        try {
            $rec = PackingMaterialChecklistHeader::find($id);
            $rec->reference_no = $request->get('reference_no');
            $rec->date = $request->get('date');
            $rec->supplier_name = $request->get('supplier_name');
            $rec->factory = $request->get('factory');
            $rec->strapping_rolls = $request->get('strapping_rolls');
            $rec->clips = $request->get('clips');
            $rec->film_rolls = $request->get('film_rolls');
            $rec->carton_pack = $request->get('carton_pack');
            $rec->update();

            $pm_rec = PackingMaterialChecklist::find($id);
            $pm_rec->weight_strapping_rolls = $request->get('weight_strapping_rolls');
            $pm_rec->thickness_strapping_rolls = $request->get('thickness_strapping_rolls');
            $pm_rec->appearance_strapping_rolls = $request->get('appearance_strapping_rolls');
            $pm_rec->width_strapping_rolls = $request->get('width_strapping_rolls');
            $pm_rec->remarks_strapping_rolls = $request->get('remarks_strapping_rolls');

            $pm_rec->hardness_clips = $request->get('hardness_clips');
            $pm_rec->remarks_clips = $request->get('remarks_clips');

            $pm_rec->old_weight_film_roll = $request->get('old_weight_film_roll');
            $pm_rec->new_weight_film_roll = $request->get('new_weight_film_roll');
            $pm_rec->old_appearance_film_roll = $request->get('old_appearance_film_roll');
            $pm_rec->new_appearance_film_roll = $request->get('new_appearance_film_roll');
            $pm_rec->old_is_sticky_film_roll = $request->get('old_is_sticky_film_roll');
            $pm_rec->new_is_sticky_film_roll = $request->get('new_is_sticky_film_roll');
            $pm_rec->remarks_film_roll = $request->get('remarks_film_roll');

            $pm_rec->old_internal_length_carton_packings = $request->get('old_internal_length_carton_packings');
            $pm_rec->old_internal_height_carton_packings = $request->get('old_internal_height_carton_packings');
            $pm_rec->old_internal_width_carton_packings = $request->get('old_internal_width_carton_packings');
            $pm_rec->new_internal_length_carton_packings = $request->get('new_internal_length_carton_packings');
            $pm_rec->new_internal_width_carton_packings = $request->get('new_internal_width_carton_packings');
            $pm_rec->new_internal_height_carton_packings = $request->get('new_internal_height_carton_packings');
            $pm_rec->old_external_length_carton_packings = $request->get('old_external_length_carton_packings');
            $pm_rec->old_external_height_carton_packings = $request->get('old_external_height_carton_packings');
            $pm_rec->old_external_width_carton_packings = $request->get('old_external_width_carton_packings');
            $pm_rec->new_external_length_carton_packings = $request->get('new_external_length_carton_packings');
            $pm_rec->new_external_width_carton_packings = $request->get('new_external_width_carton_packings');
            $pm_rec->new_external_height_carton_packings = $request->get('new_external_height_carton_packings');
            $pm_rec->weight_carton_packings = $request->get('weight_carton_packings');
            $pm_rec->appearance_carton_packings = $request->get('appearance_carton_packings');
            $pm_rec->no_of_ply_carton_packings = $request->get('no_of_ply_carton_packings');
            $pm_rec->color_carton_packings = $request->get('color_carton_packings');
            $pm_rec->remarks_carton_packings = $request->get('remarks_carton_packings');
            $pm_rec->update();

            $responseBody = $this->responseBody(true, "PackingMaterialChecklistController", "update", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingMaterialChecklistController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
